define bi_git::clone (
    $git_url = $title,
    $local_dir = undef,
    $user = undef,
    $origin = 'origin',
    $quiet = undef,
    $verbose = undef,
    $http_proxy = undef,
    $https_proxy = undef,
) {
    if $git_url == undef or !is_string($git_url) { 
        fail("'git_url' must be defined") 
    }
    
    if $local_dir == undef or !is_string($local_dir) { 
        fail("'local_dir' must be defined") 
    }
    
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    if $origin != undef {
        if is_string($origin) {
            $arg_origin = "--origin $origin"
        } else {
            fail("'origin' must be defined and a string")
        }  
    } else {
        $arg_origin = undef
    }
    
    if $verbose != undef {
        if is_bool($verbose) {
            $arg_verbose = "--quiet"
        } else {
            fail("'verbose' must be defined and a boolean")
        }  
    } else {
        $arg_verbose = undef
    }
    
    if $quiet != undef {
        if is_bool($quiet) {
            $arg_quiet = "--quiet"
        } else {
            fail("'quiet' must be defined and a boolean")
        }  
    } else {
        $arg_quiet = undef
    }
    
    $args = join(delete_undef_values([ 
        $arg_origin,
        $arg_verbose,
        $arg_quiet,
    ]), " ")
    
    if $http_proxy != undef and is_string($http_proxy) {
        $arg_http_proxy = "http_proxy=$http_proxy"
    } else {
        $arg_http_proxy = ""
    }
    
    if $https_proxy != undef and is_string($https_proxy) {
        $arg_https_proxy = "https_proxy=$https_proxy"
    } else {
        $arg_https_proxy = ""
    }
    
    require ::bi_git
    require ::bi_coreutils::stat::params
    
    $command = "$arg_http_proxy $arg_https_proxy $::bi_git::exe_path clone $args $git_url $local_dir"
    $unless = "$::bi_coreutils::stat::params::exe_path $local_dir"
    
    bi_bash::exec { "$title/$command":
        command => $command,
        unless => $unless,
        user => $user,
        group => $user,
    }
}
