define bi_git::config::config (
    $config_name = undef,
    $config_value = $title,
    $global = undef,
    $user = undef,
    $repo_path = undef,
) {
    if $user == undef or !is_string($user) { 
        fail("'user' must be defined") 
    }
    
    if $config_name == undef or !is_string($config_name) { 
        fail("'config_name' must be defined") 
    }
    
    if $config_value == undef or !is_string($config_value) { 
        fail("'config_value' must be defined") 
    }
    
    if $global == undef or !is_bool($global) { 
        fail("'global' must be defined") 
    }
    
    if $repo_path == undef or !is_string($repo_path) { 
        fail("'repo_path' must be defined") 
    }
    
    require ::bi_grep
    
    $arg_global = $global ? {
        true => '--global',
        default => undef,
    }
    
    $args = join(delete_undef_values([ 
        $arg_global, 
    ]), " ")
    
    $exec_command = "$bi_git::exe_path $args $config_name $config_value"
    $unless_command = "$bi_git::exe_path $args $config_name | $bi_grep::exe_path '$config_value'"
    
    exec { $exec_command:
        unless => $unless_command,
        user => $user,
        cwd => $repo_path,
    }
    
}